/*
 * This file is part of theme "ChicPlanet2021"
 * based on theme "CESL2019"
 * 
 * */


$(document).ready(function ($) {

	// activation de l'image de fond de page

	if($('#post-attachment .bandeau').length) {
		if($('#data-season [data-img_class=bandeau]').length) {
			$('#data-season [data-img_class=bandeau]:first').attr('data-img_url', $('#post-attachment .bandeau').attr('data-img_url'));
		}
		else {
			$("#post-attachment [data-img_class=bandeau]:first").clone().appendTo("#data-season");
		}
	}
	if($('#post-attachment .bandeau-mini').length) {
		if($('#data-season [data-img_class=bandeau-mini]').length) {
			$('#data-season [data-img_class=bandeau-mini]:first').attr('data-img_url', $('#post-attachment .bandeau-mini').attr('data-img_url'));
		}
		else {
			$("#post-attachment [data-img_class=bandeau-mini]:first").clone().appendTo("#data-season");
		}
	}

	if(!$('#data-season [data-img_class=bandeau-mini]').length) {
		$("#data-season [data-img_class=bandeau]:first").clone().attr("data-img_class","bandeau-mini").appendTo("#data-season");
	}

	page_bgInit('body', '#data-season [data-img_class=bandeau]:first', '#data-season [data-img_class=bandeau-mini]:first');



	
	// page_bgInit
	function page_bgInit(bgElement, bgData, bgDataSmall) {

		// init.
		// note : viewport_small is global var defined into _js.html
		if (window.matchMedia("(max-width: "+viewport_small+"px)").matches) {
			/* The viewport is less than, or equal to, viewport_small pixels wide*/
			page_bgSet(bgElement, bgDataSmall);
		} else {
			/* The viewport is greater than viewport_small pixels wide */
			page_bgSet(bgElement, bgData);
		}

		// en cas de redimensionement
		$(window).resize(function() {
			if ($(window).width() <= viewport_small){ 
				page_bgSet(bgElement, bgDataSmall);
			} else {
				page_bgSet(bgElement, bgData);
			}  
		});
	
	}


	// page_bgSet
	function page_bgSet(bgElement, bgData) {
		$(bgElement).css("background-image", 'url(' + $(bgData).data('img_url') + ')');
	}

});


