$(document).ready(function() {

	// check if last session expired
	//sessionClearIfExpired(); // TODO : à revoir
	
	captchaRefresh();
	inscResaInit();
});


function inscResaInit() { //console.log('inscResaInit');
	

	var formId = 'frmResa';

	
	// init select
	// stop propagation of unexpected behavior on keys F4 & F5
	var ok = $.ui.selectmenu.prototype._buttonEvents.keydown;
	$.ui.selectmenu.prototype._buttonEvents.keydown = function(e) {
		if (e.keyCode == 115 || e.keyCode == 116) e.stopPropagation();
		ok.call(this, e);
	}
	$('#'+formId+' .selectmenu').selectmenu();


	// init datepicker
	$('#'+formId+' .datepicker').datepicker();


	// init checkboxradio
	$('#'+formId+' .checkboxradio').checkboxradio({ icon: false }); //console.log('#'+formId+' .checkboxradio');


	// init cus-toggle-resa
	$('.cus-toggle-resa').each(function() { //console.log(this.id);
		$(this).on('click', function(e) { //console.log(this.id);
			var stepToGo = this.id;
			stepToGo = stepToGo.replace('cus-toggle-', '');
			console.log('stepToGo J: '+stepToGo);
			inscResaToggleNextStep(this, stepToGo);
			// if clicked button toggles to a next step
			if(0 && $('.cus-toggle-resa-content.cus-active').nextAll('.cus-toggle-resa-content').hasClass(this.id)) { //console.log('clicked button toggles to a next step');
				if(inscResaFormValidatorCheckIfSuccess('.cus-toggle-resa-content.cus-active')) {
					
					if($('.cus-toggle-resa-content.cus-active #CodeCEAnswer-y').is(':checked') && !$('.cus-toggle-CodeCEAnswer-y .cus-msg-CodeCEIfActivated').hasClass('w3-show')) {
						$('#CodeCE').addClass('error').parent().addClass('has-error');
					}

					if($('.cus-toggle-resa-content.cus-active .cus-selectmenu-Sejour:disabled').length > 0) {
						console.log('selectmenu-Sejour needed');
					} else {

						if($('.cus-toggle-resa-content.cus-active #CodeCE:not(disabled)').length > 0) {
							var item = this;
							$.ajax({
								url: 'ajaxCheckIfCEHasPeriodeSelected', cache: false
							}).done(function(d) { console.log('ajaxCheckIfCEHasPeriodeSelected done d: '+d);
								if(d > 0) {
									inscResaToggleNextStep(item, stepToGo);
								}
							});
						} else {
							inscResaToggleNextStep(this, stepToGo);
						}
					
					}
				}
			}
			// if clicked button toggles to a previous step
			if($('.cus-toggle-resa-content.cus-active').prevAll('.cus-toggle-resa-content').hasClass(this.id)) { //console.log('clicked button toggles to a previous step');
				inscResaStepCurrentUpd(stepToGo);
				cusToggleButtonAction(this.id, 'cus-toggle-resa', 'cus-toggle-resa-content');
			}
		});
	});


	// init cus-toggle-CodeCEAnswer (step 1) // TODO : optimiser traitements identiques
	$('#CodeCEAnswer-n').on('change', function() {
		if($(this).is(':checked')) { //console.log('CodeCEAnswer: changement etat à NON');
			$('#CodeCE').attr('disabled', true).val('');
			$('.cus-toggle-CodeCEAnswer').removeClass('w3-show');
			$('.cus-toggle-CodeCEAnswer-n').addClass('w3-show');
			$('.cus-toggle-Facturation').addClass('w3-show'); $('#FacturationEmail').removeAttr('disabled');
			$.ajax({
				url: 'ajaxAnswerCE', data:{'CodeCEAnswer' : this.value}, type:'POST', cache: false
			}).done(function(d) { console.log('ajaxAnswerCE "n" done d: '+d);
				if($('.cus-toggle-CodeCEAnswer-y .cus-msg-CodeCEIfActivated').hasClass('w3-show')) {
					$('.cus-toggle-CodeCEAnswer-y .cus-msg-CodeCEIfActivated').removeClass('w3-show');
					$('.cus-toggle-CodeCEAnswer-y .cus-msg-CEHasNotPeriodeSelected').removeClass('w3-show');
					$('.cus-toggle-CodeCEAnswer-y .cus-msg-CodeCEIfNotActivated').addClass('w3-show'); // TODO : verifier si correct de faire ca ici
				}
				inscResaCboUpdate('Saisons', false);
			}).error(function(d) { console.log('error d: ');console.log(d); });
		}
	});
	if($('#CodeCEAnswer-n').is(':checked')) {
		$('.cus-toggle-CodeCEAnswer').removeClass('w3-show');
		$('.cus-toggle-CodeCEAnswer-n').addClass('w3-show');
	}
	$('#CodeCEAnswer-y').on('change', function() {
		if($(this).is(':checked')) { //console.log('CodeCEAnswer: changement etat à OUI');
			$('#CodeCE').removeAttr('disabled').removeClass('error').parent().removeClass('has-error');
			$('.cus-toggle-CodeCEAnswer').removeClass('w3-show');
			$('.cus-toggle-CodeCEAnswer-y').addClass('w3-show');
			$.ajax({
				url: 'ajaxAnswerCE', data:{'CodeCEAnswer' : this.value}, type:'POST', cache: false
			}).done(function(d) { console.log(strDateTime()+' : ajaxAnswerCE done d: '+d);
				if($('.cus-toggle-CodeCEAnswer-y .cus-msg-CodeCEIfActivated').hasClass('w3-show')) {
					inscResaCEPeriodeCheck();
					inscResaCboEnableAll();
					inscResaCboUpdate('Saisons', false);
				} else {
					inscResaCboDisableAll();
				}
			}).error(function(d) { console.log('error d: ');console.log(d); });
		}
	});
	if($('#CodeCEAnswer-y').is(':checked')) {
		$('.cus-toggle-CodeCEAnswer').removeClass('w3-show');
		$('.cus-toggle-CodeCEAnswer-y').addClass('w3-show');
	}
	// check if CE has Periode when code CE is activated
	if($('.cus-toggle-CodeCEAnswer-y .cus-msg-CodeCEIfActivated').hasClass('w3-show')) { console.log('CodeCEActivated');
		inscResaCECodeCheck();
		inscResaCEPeriodeCheck();
		inscResaCboEnableAll();
		//~ $('.cus-toggle-Facturation').removeClass('w3-show');
	}
	if($('.cus-toggle-CodeCEAnswer-y').hasClass('w3-show')) {
		$('#CodeCE').removeAttr('disabled');
	}
	// init #CodeCE button events 
	$('#btn-CodeCE').on('click', function(e){
		e.preventDefault();
		inscResaCECodeCheck();
	});

	// inscResaFacturationRefresh
	if($('#FacturationEmail').length) {
		inscResaFacturationRefresh();
	}

	// init cus-selectmenu-Sejour (step 1)
	$('.cus-selectmenu-Sejour').each(function() { //console.log(this.id);
		$(this).on("selectmenuchange", function(event, ui) { //console.log(ui);
			inscResa_selectmenuchange(this, ui);
		});
	});


	$('#IDSejour').on("selectmenuchange", function(event, ui) {
		if(ui.item.value != "") {
			inscResaInfosCompRefresh();
		}	
	});


	// init cus-toggle-Accompagne (step 2)
	$('#Accompagne-n').on('change', function() {
		if($(this).is(':checked')) {
			$('#NomAcc, #PrenomAcc').attr('disabled', true);
			$('.cus-toggle-Accompagne').removeClass('w3-show');
		}
	});
	$('#Accompagne-y').on('change', function() {
		if($(this).is(':checked')) {
			$('.cus-toggle-Accompagne-y').addClass('w3-show');
			$('#NomAcc, #PrenomAcc').removeAttr('disabled');
		}
	});


	//~ // init cus-toggleselect-Parent (step 3)
	//~ $('#cus-toggleselect-Parent').on('selectmenuchange', function( event, ui ) { //console.log('#cus-toggleselect-Responsable selectmenuchange: '+this.id);
		//~ $('.cus-active.'+this.id+' input[data-validation]:not(disabled)').each(function() { //console.log(' input[data-validation] : '+this.id);
			//~ $(this).attr('disabled', true);
		//~ });
		//~ $('.cus-active.'+this.id).removeClass('cus-active w3-show');
		//~ inscResaToggleSelectmenuRefresh(this.id);
	//~ });
	//~ inscResaToggleSelectmenuRefresh('cus-toggleselect-Parent');


	// init cus-toggleselect-Responsable (step 3)
	$('#cus-toggleselect-Responsable').on('selectmenuchange', function( event, ui ) { //console.log('#cus-toggleselect-Responsable selectmenuchange: '+this.id);
		$('.cus-active.'+this.id+' input[data-validation]:not(disabled)').each(function() { //console.log(' input[data-validation] : '+this.id);
			$(this).attr('disabled', true);
		});
		$('.cus-active.'+this.id).removeClass('cus-active w3-show');
		inscResaToggleSelectmenuRefresh(this.id);
	});
	inscResaToggleSelectmenuRefresh('cus-toggleselect-Responsable');


	// init check tel Parents/Tuteur (step 3)
	$('.TelPere').on('validation', function(evt, valid) {
		inscResaTelCheck('.TelPere', this.name, valid);
    });
	$('.TelMere').on('validation', function(evt, valid) {
		inscResaTelCheck('.TelMere', this.name, valid);
    });
	$('.TelTuteur').on('validation', function(evt, valid) {
		inscResaTelCheck('.TelTuteur', this.name, valid);
    });


	// init. #btnCaptchaRefresh button events (step 5)
	$('#btnCaptchaRefresh').on('click', function(e) {
		e.preventDefault();
		captchaRefresh();
	});
	

	//  init #btnChangeContactEmail button events (step 5)
	$('#btnChangeContactEmail').on('click', function(e) {
		e.preventDefault();
		var title = 'Modifier votre adresse email';
		var content = 
		'<div class="w3-bar w3-show-inline-block cus-w-xl">'+
			'<div class="w3-bar-item cus-w-xl">'+
				'<label for="ContactEmailNew">Votre adresse email de contact</label>'+
				'<input class="" id="ContactEmailNew" type="email" name="ContactEmailNew" value="'+$('[name=contact_email]').val()+'" required data-validation="email" data-validation-error-msg="Une Adresse email valide est requise">'+
			'</div>'+
		'</div>';
		var okText = 'Modifier';
		var cancelText = 'Annuler';
		var uiDialog = 'ui-dialog-box';
		$('<div />').attr({'id' : uiDialog, 'title' : title}).html($('<div />').html(content)).appendTo('body');
		var cfgButtons = [];
		cfgButtons.push({
			text: okText,
			click: function() { //console.log('ok');
				var email = $('[name=ContactEmailNew]').val();
				$(this).dialog("close");
				$.ajax({
					data: {'do': 'inscResaChangeContactEmail', 'ContactEmailNew': email}, cache: false
				}).done(function(d) { //console.log('inscResaChangeContactEmail done d: ');console.log(d);
					if(d == 1) {
						$('#contact_email').html(email);
						$('[name=contact_email]').val(email);
					}
				});
				
			}
		});
		if(cancelText !== undefined && cancelText != '') {
			cfgButtons.push({
				text: cancelText,
				click: function() {
					console.log('cancel');
					$(this).dialog("close");
				}
			});
		}
		$('#'+uiDialog).dialog({
			resizable: false,
			height: "auto",
			width: "auto",
			modal: true,
			buttons: cfgButtons,
			close: function(event, ui) {$(this).remove();}
		});
		
	});


	// check if email confirmation match with email
	// TODO : use jquery form validator instead (with a custom check)
	$('#EmailPereConf, #EmailMereConf, #EmailTuteurConf').on('blur', function(e){
		if(this.value != $($(this).data('validation-cus-equal-to')).val()) {
			uiDialogBoxInfo(
				"Une erreur s'est produite",
				"L'adresse mail de confirmation est différente de l'adresse mail de référence",
				'Fermer'
			);
		}
	});	



	
	//~ if (!is_native_android) {
		$("#Taille").mask("?9.99");
		$("#Pointure").mask("?99");
		$("#TelDomPere").mask("?99 99 99 99 99");
		$("#TelGSMPere").mask("?99 99 99 99 99");
		$("#TelProPere").mask("?99 99 99 99 99");
		$("#TelDomMere").mask("?99 99 99 99 99");
		$("#TelGSMMere").mask("?99 99 99 99 99");
		$("#TelProMere").mask("?99 99 99 99 99");
		$("#TelDomTuteur").mask("?99 99 99 99 99");
		$("#TelGSMTuteur").mask("?99 99 99 99 99");
		$("#TelProTuteur").mask("?99 99 99 99 99");
		$("#TelUrgence").mask("?99 99 99 99 99");
		$("#TelContact").mask("?99 99 99 99 99");
	//~ }

	if($("#DateNaissance").val().length > 0) {
		$('#DateNaissance').val($('#DateNaissance').val().split("-").reverse().join("/"));
	}
	$("#DateNaissance").mask("?99/99/9999");


	// init (next) steps buttons events 
	$('#btn-bottom-step-lesejour').on('click', function(e) {
		e.preventDefault();
		if(inscResaOptionsValidate()) {
			//~ inscResaAssuTextRefresh(); //#RG20220330 commented : not needed here
			$('#cus-toggle-lejeune').trigger('click');
		}
		//~ inscResaStepMsgSejour('#cus-toggle-lesejour');
	});
	$('#btn-bottom-step-lejeune').on('click', function(e) {
		e.preventDefault();
		//~ inscResaAssuTextRefresh(); //#RG20220330 commented : not needed here
		if($('#cus-toggle-lesresponsables').length) {
			$('#cus-toggle-lesresponsables').trigger('click');
		} else {
			$('#cus-toggle-autresinfos').trigger('click');
		}
		//~ inscResaStepMsgSejour('#cus-toggle-lejeune');
	});
	$('#btn-bottom-step-lesresponsables').on('click', function(e) {
		e.preventDefault();
		//~ inscResaAssuTextRefresh(); //#RG20220330 commented : not needed here
		$('#cus-toggle-autresinfos').trigger('click');
		//~ inscResaStepMsgSejour('#cus-toggle-lesresponsables');
		inscResaFacturationRefresh();
	});
	$('#btn-bottom-step-autresinfos').on('click', function(e) {
		e.preventDefault();
		//~ inscResaAssuTextRefresh(); //#RG20220330 commented : not needed here
		$('#cus-toggle-fin').trigger('click');
		//~ inscResaStepMsgSejour('#cus-toggle-autresinfos');
	});
	$('#btn-bottom-step-fin').on('click', function(e) {
		e.preventDefault();
		if( $("#Captcha").length ) {
			cap = $("#Captcha").val();
		} else {
			var cap = '';
		}
		if (cap != '') {
			$.ajax({type:"POST", url: '/captcha_check', cache: false, data: {'Captcha' : cap} })
				.done(function(d) { //console.log('robotValidate :'); console.log(d);
					okCaptcha = d;
					if (okCaptcha == '1') {
						if(inscResaFormValidatorCheckIfSuccess('.cus-toggle-resa-content.cus-active')) { inscResaFormSubmit(formId); }
					} else { //console.log('validation: ' + okCaptcha);
						uiDialogBoxInfo("Erreur du code de sécurité", "Le résultat donné ne correspond pas à celui attendu.", 'Fermer');
					}
				})
				.error(function(d) { console.log('ajaxCaptchaValidate: error'); });
		} else {
			inscResaFormValidatorCheckIfSuccess('.cus-toggle-resa-content.cus-active');
		}
		//~ inscResaStepMsgSejour('#cus-toggle-fin');
	});

	
	// init previous (steps) buttons events 
	$('#btn-bottom-prev-lejeune').on('click', function(e) {
		e.preventDefault();
		$('#cus-toggle-lesejour').trigger('click');
	});
	$('#btn-bottom-prev-fin').on('click', function(e) {
		e.preventDefault();
		$('#cus-toggle-autresinfos').trigger('click');
	});
	$('#btn-bottom-prev-lesresponsables').on('click', function(e) {
		e.preventDefault();
		$('#cus-toggle-lejeune').trigger('click');
	});
	$('#btn-bottom-prev-autresinfos').on('click', function(e) {
		e.preventDefault();
		$('#cus-toggle-lesresponsables').trigger('click');
	});


	// update cascade selects
	inscResaCboUpdate('Saisons', false);


	// switch to (last) current step (when page is reloaded)
	$.ajax({
		cache: false, data: {'do' : 'inscResaStepCurrent'}
	}).done(function(d) { console.log('inscResaStepCurrent done d: '+d);
		if(d.length > 0) {
			$('#cus-toggle-'+d).prevAll('.cus-toggle-disabled').removeClass('cus-toggle-disabled');
			cusToggleSwitch('cus-toggle-'+d, 'cus-toggle-resa', 'cus-toggle-resa-content');
		} else {
			cusToggleSwitch('cus-toggle-lesejour', 'cus-toggle-resa', 'cus-toggle-resa-content');
		}
	}).error(function(d) { console.log('error d: ');console.log(d); });


	// disable paste on email confirmation
	$('#EmailPereConf').bind('paste', function(e){e.preventDefault();});	
	$('#EmailMereConf').bind('paste', function(e){e.preventDefault();});	
	$('#EmailTuteurConf').bind('paste', function(e){e.preventDefault();});	


	// init cancel resa button events
	$('#btn-resa-cancel').on('click', function(e) {
		var title = 'Annuler la réservation en cours';
		var content = 'Souhaitez-vous annuler ou continuer la réservation en cours ?';
		var okText = 'Annuler la réservation';
		var cancelText = 'Continuer la réservation';
		var uiDialog = 'ui-dialog-box';
		$('<div />').attr({'id' : uiDialog, 'title' : title}).html($('<div />').html(content)).appendTo('body');
		var cfgButtons = [];
		cfgButtons.push({
			text: okText,
			click: function() { //console.log('ok');
				$(this).dialog("close");
				sessionStorage.clear(); //console.log('sessionStorage.length: '+sessionStorage.length);
				$.ajax({
					data: {'do': 'sessionReset'}, cache: false
				}).done(function(d) { //console.log('done d: ');console.log(d);
					window.location.href = window.location.href; // reload page without resend previous data
				});
				
			}
		});
		if(cancelText !== undefined && cancelText != '') {
			cfgButtons.push({
				text: cancelText,
				click: function() {
					console.log('cancel');
					$(this).dialog("close");
				}
			});
		}
		$('#'+uiDialog).dialog({
			resizable: false,
			height: "auto",
			width: "auto",
			modal: true,
			buttons: cfgButtons,
			close: function(event, ui) {$(this).remove();}
		});
	});

	inscResaOptionsInit();

	// refresh form validator
	inscResaFormValidatorRefresh();
}


function inscResaOptionsInit() {

	$('#Periode').attr('disabled', false);

	//~ console.log($('#Periode').attr('disabled'));
	if($('#Periode').attr('disabled') !== undefined) {
		//~ console.log($('#Periode').val());
	}

	$('#periodeOpts :checked').each(function() {
		$(this).trigger('change');
	});

	//~ console.log('#periodeOpts .selectAlwaysSelected');
	//~ $('#periodeOpts .selectAlwaysSelected').prop('checked', true);

}

function inscResaOptionsValidate() {
	//TODO controle options sélectionnées
	var optsCount = $('#periodeOpts').length; console.log('optsCount : '); console.log(optsCount);
	if(optsCount < 1) { return true; } // cas PAS d'option proposée
	else { // cas option(s) proposée(s)
		var optsCountChecked = $('#periodeOpts :checked').length; console.log('optsCountChecked : '); console.log(optsCount);
// TODO : gérer cas resaSelectOneOfThisTypeMustBeSelected		
		if(!(optsCountChecked > 0 && inscResaTarifTotalCompute() >= 0)) {
			uiDialogBoxInfo("Choix des tarifs", "Au moins un tarif doit être sélectionné", 'Fermer');
			return;
		}
		return true;
	}
}


function inscResaToggleNextStep(item, stepToGo) { console.log('inscResaToggleNextStep : '+item.id+' stepToGo: '+stepToGo);
	inscResaStepSendData('.cus-toggle-resa-content.cus-active', stepToGo);
	// toggles to immediately next step only if next step has 'item.id' as class
	if($('.cus-toggle-resa-content.cus-active').next().hasClass(item.id)) {
		$(item).removeClass('cus-toggle-disabled');
		inscResaStepCurrentUpd(stepToGo);
		cusToggleButtonAction(item.id, 'cus-toggle-resa', 'cus-toggle-resa-content');
	} else {
		if(!$(item).hasClass('cus-toggle-disabled')) {
			inscResaStepCurrentUpd(stepToGo);
			cusToggleButtonAction(item.id, 'cus-toggle-resa', 'cus-toggle-resa-content');
		}
	}
}


function inscResaTelCheck(itemsSelector, itemName, valid) {	//console.log('Input "'+itemName+'" is ' + (valid ? 'VALID' : 'NOT VALID'));
	if(valid) {
		$(itemsSelector+':required').not('[name='+itemName+']').removeAttr('required').attr('data-validation-optional', 'true').trigger('blur');
	} else {
		if($(itemsSelector+'.valid').length == 0) {
			$(itemsSelector).attr('required', true).removeAttr('data-validation-optional');
		}
	}
}



function inscResaCECodeCheck() {
	codeCE = $('#CodeCE').val();
	if(codeCE!='') {
		$.ajax({
			type:"POST", url: 'ajaxVerifCE', cache: false, data: {'codeCE' : codeCE}
		}).done(function(d) { console.log('ajaxVerifCE: '+d);
			if(d == 0) {
				$('#CodeCE').addClass('error').parent().addClass('has-error');
				$('.cus-toggle-CodeCEAnswer-y .cus-msg-CodeCEIfActivated').removeClass('w3-show');
				$('.cus-toggle-CodeCEAnswer-y .cus-msg-CodeCEIfNotActivated').addClass('w3-show');
				$('.cus-toggle-CodeCEAnswer-y .cus-msg-CodeCEUnknown').addClass('w3-show');
				//~ $('.cus-toggle-Facturation').addClass('w3-show');
			}
			if(d == '1' || d == '2') {
				$('#CodeCE').removeClass('error').parent().removeClass('has-error');
				$('.cus-toggle-CodeCEAnswer-y .cus-msg-CodeCEUnknown').removeClass('w3-show');
				$('.cus-toggle-CodeCEAnswer-y .cus-msg-CodeCEIfNotActivated').removeClass('w3-show');
				$('.cus-toggle-CodeCEAnswer-y .cus-msg-CodeCEIfActivated').addClass('w3-show');
				inscResaCEPeriodeCheck();
				inscResaCboUpdate('Saisons', false);
				inscResaCboEnableAll();
				//~ $('.cus-toggle-Facturation').removeClass('w3-show');
			}
			if(d == 0 || d == '1') {
				$('.cus-toggle-Facturation').addClass('w3-show'); $('#FacturationEmail').removeAttr('disabled');
			} else {
				$('.cus-toggle-Facturation').removeClass('w3-show'); $('#FacturationEmail').attr('disabled', true);
			}
		}).error(function(d) { console.log(d); return 0;});	
	}
}  



function inscResaCEPeriodeCheck() { console.log('ajaxCheckIfCEHasPeriodeSelected');
	$.ajax({
		url: 'ajaxCheckIfCEHasPeriodeSelected', cache: false
	}).done(function(d) { console.log('ajaxCheckIfCEHasPeriodeSelected done d: '+d);
		if(d == "0") { $('.cus-toggle-CodeCEAnswer-y .cus-msg-CEHasNotPeriodeSelected').addClass('w3-show'); }
	});
}



function inscResaCboDisableAll() { //console.log('inscResaCboDisableAll');
	$('#Saison').selectmenu("disable");
	$('#IDSejour').selectmenu("disable");
	$('#Periode').selectmenu("disable");
	$('#VilleDepart').selectmenu("disable");
	$('#box-options').hide();
}


function inscResaCboDisableNextAll(item) { //console.log('inscResaCboDisableNextAll: '+item);
	$(item).closest('div').nextAll().each(function() {
		var sel = $(this).find('select');
		sel.val('');
		sel.selectmenu("option", "disabled", true);
		sel.selectmenu("refresh");
		$('#box-options').hide();
	});
}


function inscResaCboEnableAll() { console.log('inscResaCboEnableAll');
	if($('#Saison').val() != '') {
		$('#Saison').selectmenu("enable");
		$('#IDSejour').selectmenu("enable");
	} else {
		$('#Saison').selectmenu("enable");
	}
	if($('#IDSejour').val() != '') {
		$('#IDSejour').selectmenu("enable");
		$('#Periode').selectmenu("enable");
	}
	if($('#Periode').val() != '') {
		$('#Periode').selectmenu("enable");
		$('#box-options').show();
		$('#VilleDepart').selectmenu("enable");
	}
}


function inscResaCboUpdate(item, disabled) { console.log('inscResaCboUpdate: '+item);
	switch (item) {
		case 'Saisons':
			inscResaCboUpdateSaisons(disabled);
			break;
		case 'Sejours':
			inscResaCboUpdateSejours(disabled);
			break;
		case 'Periodes':
			inscResaCboUpdatePeriodes(disabled);
			break;
		case 'Villes':
			inscResaCboUpdateVilles(disabled);
			break;
		case 'Options':
			inscResaCboUpdateOptions(disabled);
			break;
	}
}


function inscResaCboUpdateNext(item, itemNext, d, itemDisabled) { console.log('inscResaCboUpdateNext : '+item+' -- itemNext : '+itemNext);
	$(item).html(d).promise().done(function() {
		if(itemDisabled == false && $(this).find('option:selected').prop('disabled') == false && ($('.cus-msg-CodeCEIfActivated').hasClass('w3-show') || $('[name=CodeCEAnswer]:checked').val() == 'n')) {
			console.log('inscResaCboUpdateNext : enable select');
			$(this).selectmenu('enable');
		}
		inscResaFormValidatorRefresh();
		console.log('inscResaCboUpdateNext : refresh select');
		$(this).selectmenu('refresh');
		$(item+"-button").focus(); // TODO : get selector by $().selectmenu()
		if(this.get(0).value == "") {
			inscResaCboDisableNextAll(item);
		} else {
			var disabled = false;
			if($(this).find('option:selected').prop('disabled')) {inscResaCboDisableNextAll(item); disabled = true;}
			if(itemNext.length) { console.log('inscResaCboUpdateNext : update next : '+itemNext);
				inscResaCboUpdate(itemNext, disabled);
			}
		}
	});
}


function inscResaCboUpdateSaisons(disabled) { //console.log('inscResaCboUpdateSaisons');
	$.ajax({
		cache: false, data: {'do' : 'ajaxCboSaisons'}
	}).done(function(d) { console.log('inscResaCboUpdateSaisons : done d: '); console.log('ok'); //console.log(d);
		inscResaCboUpdateNext('#Saison', 'Sejours', d, disabled);
	}).error(function(d) { console.log('error d: ');console.log(d); });
}


function inscResaCboUpdateSejours(disabled) { //console.log('inscResaCboUpdateSejours');
	$.ajax({
		cache: false, data: {'do' : 'ajaxCboSejours', 'Saison' : $('#Saison').val()}
	}).done(function(d) { console.log('inscResaCboUpdateSejours : done d: '); console.log('ok'); //console.log(d);
		inscResaCboUpdateNext('#IDSejour', 'Periodes', d, disabled);
		inscResaInfosCompRefresh();
	}).error(function(d) { console.log('error d: ');console.log(d); });
} 


function inscResaCboUpdatePeriodes(disabled) { //console.log('inscResaCboUpdatePeriodes');
	$('#box-options').hide();
	$.ajax({
		cache: false, data: {'do' : 'ajaxCboPeriodes', 'Sejour' : $('#IDSejour').val()}
	}).done(function(d) { console.log('inscResaCboUpdatePeriodes done d: '); console.log('ok'); //console.log(d);
		//~ inscResaCboUpdateNext('#Periode', 'Villes', d, disabled);
		inscResaCboUpdateNext('#Periode', 'Options', d, disabled);
		//~ $('#box-options').show();
		inscResaTarifTotalUpdate();
	}).error(function(d) { console.log('error d: ');console.log(d); });
} 


function inscResaCboUpdateOptionsold(disabled) { console.log('inscResaCboUpdateOptions : '+$('#Periode').val());
	//~ $('#box-options').hide();
	$('#box-options').html('<div class="ui-dialog-loading32w"></div>');
	$.ajax({
		cache: false, data: {'do' : 'ajaxCboOptions2', 'Periode' : $('#Periode option:selected').val()}
	}).done(function(d) { console.log('inscResaCboUpdateOptions done d: '); console.log('ok'); //console.log(d);
		d = parseJSON(d);
		if(d.success !== undefined && d.mode !== undefined) {
			if(d.mode == 'options') {
				console.log('mode : options');
				$('#box-options').html(d.success).promise().done(function() {
					inscResaOptionsInit();
					inscResaAssuTextRefresh(); //#RG20220330 needed if a page refresh occurs
					inscResaTarifTotalUpdate();
		
					//~ $(this).on("selectmenuchange", function(event, ui) {
						//~ inscResaTarifTotalUpdate();
						//~ inscResa_selectmenuchange(this, ui);
					//~ });
				});
			}
			if(d.mode == 'ville') {
				console.log('mode : ville');
				$('#box-options').html(d.success).promise().done(function() {
					$('#box-options .selectmenu').selectmenu();
					inscResaCboUpdateNext('#VilleDepart', '', $('#VilleDepart').html(), disabled);
					inscResaAssuTextRefresh(); //#RG20220330 needed if a page refresh occurs
					inscResaTarifTotalUpdate();
					//~ $(this).on("selectmenuchange", function(event, ui) {
					$('#VilleDepart').on("selectmenuchange", function(event, ui) {
						$.ajax({
							//~ cache: false, data: { 'do' : 'inscResaStepCurrent', 'VilleDepart' : $('#VilleDepart option:selected').val()}
							cache: false, data: {'VilleDepart' : $('#VilleDepart option:selected').val(), 'do' : 'inscResaStepCurrent', 'optVilleDepart' : $('#VilleDepart option:selected').data('id')}
						}).done(function(d) { console.log('VilleDepart done d: ');console.log(d); });
						//~ inscResaAssuTextRefresh(); //#RG20220330 commented : not needed here
						inscResaTarifTotalUpdate();
						//~ inscResa_selectmenuchange(this, ui);
					});
				});
			}
			$('#box-options').show();
		}
	}).error(function() { console.log('error'); });
} 



function inscResaCboUpdateOptions(disabled) { console.log('inscResaCboUpdateOptions : '+$('#Periode').val());
	$('#box-options').html('<div class="ui-dialog-loading32w"></div>');
	$.ajax({
		cache: false, data: {'do' : 'ajaxCboOptions2', 'Periode' : $('#Periode option:selected').val()}
	}).done(function(d) { console.log('inscResaCboUpdateOptions done d: '); console.log('ok'); //console.log(d);
		d = parseJSON(d);
		if(d.success !== undefined && d.mode !== undefined) {
			$('#box-options').html(d.success).promise().done(function() {
				if(d.mode == 'options') {
					console.log('mode : options');
					inscResaOptionsInit();
				}
				if(d.mode == 'ville') {
					console.log('mode : ville');

					$('#box-options .selectmenu').selectmenu();
					inscResaCboUpdateNext('#VilleDepart', '', $('#VilleDepart').html(), disabled);
					$('#VilleDepart').on("selectmenuchange", function(event, ui) {
						$.ajax({
							cache: false, data: {'VilleDepart' : $('#VilleDepart option:selected').val(), 'do' : 'inscResaStepCurrent', 'optVilleDepart' : $('#VilleDepart option:selected').data('id')}
						}).done(function(d) { console.log('VilleDepart done d: ');console.log(d); });
						inscResaTarifTotalUpdate();
					});

				}
				console.log('#periodeOpts .selectAlwaysSelected');
				$('#periodeOpts .selectAlwaysSelected').prop('checked', true);
				inscResaAssuTextRefresh(); //#RG20220330 needed if a page refresh occurs
				inscResaTarifTotalUpdate();
			});
			$('#box-options').show();
		}
	}).error(function() { console.log('error'); });
} 


function inscResaInfosCompRefresh() { //console.log('inscResaInfosCompRefresh');
	sejour = $('#IDSejour').val();	
	if(sejour != '') {
		$.ajax({
			data: {'do' : 'ajaxSejourInfosComp', 'Sejour' : sejour}, cache: false
		}).done(function(d) { //~ console.log(d);
			$('#ResaInfosComp').html(d);
			$('#ResaInfosComp .checkboxradio').checkboxradio({icon: false});
			$('#ResaInfosComp .controlgroup-vertical').controlgroup({direction: "vertical"});
			inscResaFormValidatorRefresh();
		}).error(function(d) { console.log(d); });	
	} else {
		$('#ResaInfosComp').html('');
	}
}

function inscResaAssuTextRefresh() { console.log('inscResaAssuTextRefresh');
		//~ codeCE = $('#CodeCE').val();
		//~ periodeId = $('#Periode').val();
		//~ villeDep = $('#VilleDepart').val();
		$.ajax({
			//~ data: {'do' : 'ajaxAssuranceTexte', 'codeCE' : codeCE, 'periodeId' : periodeId, 'villeDep' : villeDep}, type: 'post', cache: false
			data: {'do' : 'ajaxAssuranceTexte'}, type: 'post', cache: false
		}).done(function(d) { console.log('inscResaAssuTextRefresh done : '); console.log('ok'); //console.log(d);
			if(d != '0') {
				$('#box-assu').show();
				$('#assu-texte').html(d);
			}
			else {
				$('#box-assu').hide();
			}
			//inscResaInit();  #NOTA JMR: Loop if called
			var formId = 'frmResa';
			$('#'+formId+' .checkboxradio').checkboxradio({ icon: false }); //console.log('#'+formId+' .checkboxradio');
			inscResaFormValidatorRefresh();
		}).error(function(d) { console.log(d); });	
}




function inscResaFacturationRefresh() { //console.log('inscResaFacturationRefresh');
	if($('#FacturationEmail').length) {
		var optionHTML = $('#FacturationEmail option:first-child')[0].outerHTML; //console.log('optionHTML:');	console.log(optionHTML);
		var fieldFacturationEmail = $('#FacturationEmail').val();
		var optionSelected = '';
		var emailPere = $('#EmailPere:required').val();
		var emailMere = $('#EmailMere:required').val();
		var emailTuteur = $('#EmailTuteur:required').val();
		//~ var fieldParent = $('#cus-toggleselect-Parent').val();
		//~ if((fieldParent == 'P' || fieldParent == 'PM') && emailPere != '') {
		if(emailPere != '') {
			if(fieldFacturationEmail != '' && fieldFacturationEmail == emailPere) {optionSelected = ' selected';} else {optionSelected = '';}
			optionHTML += '<option value="'+emailPere+'"'+optionSelected+'>Parent 1 ('+emailPere+')</option>';
		}
		//~ if((fieldParent == 'M' || fieldParent == 'PM') && emailMere != '') {
		if(emailMere != '') {
			if(fieldFacturationEmail != '' && fieldFacturationEmail == emailMere) {optionSelected = ' selected';} else {optionSelected = '';}
			optionHTML += '<option value="'+emailMere+'"'+optionSelected+'>Parent 2 ('+emailMere+')</option>';
		}
		if(emailTuteur != '') {
			if(fieldFacturationEmail != '' && fieldFacturationEmail == emailTuteur) {optionSelected = ' selected';} else {optionSelected = '';}
			optionHTML += '<option value="'+emailTuteur+'"'+optionSelected+'>Le tuteur ('+emailTuteur+')</option>';
		}
		$('#FacturationEmail').html(optionHTML).selectmenu('refresh');
	}
}


function inscResaToggleSelectmenuRefresh(itemId) {
	if($('#'+itemId).val() != '') { //console.log('inscResaToggleSelectmenuRefresh(itemId)');
		$('.'+itemId+'-'+$('#'+itemId).val()).addClass('cus-active w3-show');
		$('.'+itemId+'-'+$('#'+itemId).val()+' :disabled').removeAttr('disabled').promise().done(function() {
			inscResaFormValidatorRefresh();
			$('#'+itemId).trigger('blur'); // needed to trigger form validator
		});
	}
}


function inscResaFormValidatorRefresh() {
	$.validate({
		//~ modules : 'html5, location, date, security, file',
		//~ modules : 'html5, location, date, security, file',
		//~ onModulesLoaded : function() {
			//~ $('#country').suggestCountry();
		//~ },
		//~ onModulesLoaded : function() {
			//~ alert('All modules loaded!');
		//~ },
		form : '#frmResa',
		validateHiddenInputs : true,
		borderColorOnError : '#ff5d00'
	});
}


/**
* inscResaFormValidatorCheckIfSuccess(form)
* 
* Do trigger "blur" (inputs checking by jQuery-Form-Validator) on all required input elements found into "form"
* if one element has "error" class, do scroll to it and returns FALSE
* if all elements has "valid" class, returns TRUE
**/
function inscResaFormValidatorCheckIfSuccess(form) {
	$(form+' :required').each(function() { //console.log('this.id:'+this.id);
		$(this).trigger('blur');
	});
	if($(form).find('.error:required').length) {
		scrollToElement($(form).find(':required'));
		return false;
	} else {
		return true;;
	}
}


function inscResaFormSubmit(formId) { console.log('inscResaFormSubmit');
	var frm = '#'+formId; console.log($(frm).serializeArray());
	var bgWait = '#bg-waiting';
	$(bgWait).fadeTo(400,0.8);
	$.post('/ajaxAddResa', $(frm).serializeArray()).done(function(d) { console.log('inscResaFormSubmit post response :'); console.log(d);
		d = parseJSON(d);
		if(d.error !== undefined) {
			$(bgWait).hide();
			uiDialogBoxInfo('Une erreur s\'est produite', d.error, 'Ok');
		}
		if(d.success !== undefined) {
		}
		if(d.url_open !== undefined) { 
			console.log(d);
			window.location = d.url_open;
		}
	});

}


function inscResaStepSendData(stepItem, stepToGo) { console.log('inscResaStepSendData');
	// detect if form has data-type "transportAR" #TODO : do this on server side
	if($(stepItem+' input[data-type=transportAR]').length) {
		$(stepItem+' input[data-type=transportAR]:first-child').before('<input type="hidden" name="usedAsTransport" value="1" checked />');
	}

	var params = $.param({'do' : 'StepSendData'})+'&stepToGo='+stepToGo+'&'+$.param($(stepItem+' input').serializeArray())+'&'+$.param($(stepItem+' select').serializeArray())+'&'+$.param($(stepItem+' textarea').serializeArray());
	//console.log(params);
	$.ajax({
		type: 'post', cache: false, data: params
	}).done(function(d) { console.log('inscResaStepSendData done d: ');console.log(d);
	}).error(function(d) { console.log('error d: ');console.log(d); });
}


function inscResaStepCurrentUpd(stepCurrent) { console.log('inscResaStepCurrentUpd:'+stepCurrent);
	//~ inscResaAssuTextRefresh(); //#RG20220330 commented
	var params = $.param({'do' : 'StepSendData'})+'&stepToGo='+stepCurrent;	//console.log(params);
	$.ajax({
		type: 'post', cache: false, data: params
	}).done(function(d) { inscResaAssuTextRefresh(); //#RG20220330 added
 //console.log('done d: ');console.log(d);
	}).error(function(d) { console.log('error d: ');console.log(d); });
}


function inscResaStepMsgSejour(target) { //console.log('inscResaStepMsgSejour');
	msg =
		$('#IDSejour option:selected').text()+' '+
		$('#Periode option:selected').text()+' au départ de '+
		$('#VilleDepart option:selected').text();
	$(target+' .msg').html(msg);
}


function inscResaStepMsgJeune(target) { //console.log('inscResaStepMsgJeune');
	msg =
		$('#NomIns').val()+' '+
		$('#PrenomIns').val()+' '+
		'né(e) le '+$('#DateNaissance').val();
	$(target+' .msg').html(msg);
}


function inscResaStepMsgResponsables(target) { //console.log('inscResaStepMsgResponsables');
	//console.log($('[name=Responsable]:checked').get(0).labels[0].innerText);
	var msg = $('[name=Responsable]:checked').get(0).labels[0].innerText+' :';

	responsables = $('[name=Responsable]').val();
	if(responsables == 'P' || responsables == 'PM') {
		msg += ' '+$('#NomPere').val()+' '+$('#PrenomPere').val();
	}
	if(responsables == 'PM') {
		msg += ' & ';
	}
	if(responsables == 'M' || responsables == 'PM') {
		msg += ' '+$('#NomMere').val()+' '+$('#PrenomMere').val();
	}
	if(responsables == 'T') {
		msg += ' '+$('#NomTuteur').val()+' '+$('#PrenomTuteur').val();
	}
	$(target+' .msg').html(msg);
}


function inscResaTarifTotalCompute(form) { console.log('inscResaTarifTotalCompute');
	if(form === undefined) { var form = '#frmResa'; }
    var sum = 0;
    $('#frmResa').find('[data-tarif]:checked:not(:disabled)').each(function() {
        console.log('tarif :');console.log($(this).data('tarif'))
        sum += Number($(this).data('tarif'));
        console.log('sum :');console.log(sum)
    });
	return sum;
}


function inscResaTarifTotalUpdate(form) { console.log('inscResaTarifTotalUpdate');
	if(form === undefined) { var form = '#frmResa'; }
    var sum = inscResaTarifTotalCompute(form);
	if(sum < 0) { sum = 0;}
	$('.resaTarifTotal').html(sum);
}



function captchaRefresh() {     
	console.log('captchaRefreh');
	$.ajax({
		type:"POST", url: '/captcha_url', cache: false
	}).done(function(d) {
		$('#imgCaptcha').attr('src',d);
	});
 }


function inscResa_selectmenuchange(i, ui) { //console.log(i);
	if(ui.item.value == "") {
		inscResaCboDisableNextAll(i);
		inscResaTarifTotalUpdate();
		console.log('select empty');
	} else {
		$(i).trigger('blur'); // needed to trigger form validator
		if($(i).data('cus-selectmenu-next') != '') {
			inscResaCboUpdate($(i).data('cus-selectmenu-next'), false);
			inscResaInfosCompRefresh;
			inscResaCboEnableAll();
		}
	}
}

