/*
 * This file is part of Dotclear theme "CESL2014"
 * 
 * */

var regVirgule = new RegExp("[,]+", "g");
var regEspace  = new RegExp("[ ]+", "g");
var reg2points = new RegExp("[:]+", "g");

function sejourPictoTxt(e, c) {
	$.each(c.split(regVirgule), function (i, v) {
		var t = $(v).attr('data-type');
		$.each($(v).attr('data-value').split(regVirgule), function (j, w) {
			if(w.trim().length) {
				//$(e).append($('<div>').addClass('sejour-picto '+t));
				//$(e+'>div:last').append($('<div>').text(w.trim()));
				//$(e+'>div:last').append($('<div>').text(t));
				$(e).prepend($('<div>').addClass('sejour-picto '+t));
				$(e+'>div:first').append($('<div>').text(w.trim()));
				$(e+'>div:first').append($('<div>').text(t));
			}
		});
	});
}

function sejourPictoImg(e, c) {
	$.each(c.split(regVirgule), function (i, v) {
		if($(v).length) {
			//$(e).append($('<div>').addClass('sejour-picto'));
			//$(v.trim()+' img').appendTo($(e+'>div:last'));		
			$(e).prepend($('<div>').addClass('sejour-picto'));
			$(v.trim()+' img').appendTo($(e+'>div:first'));		
		}
	});
}

function sejourDescription(e, c) {
	if($(c).html()) {
		$(c).children().appendTo($(e));
		$(e).show();
	}
}

function sejourDataVilles(d) {
	var out = [];
	$.each(d.split(regVirgule), function (i, v) {
		var v = v.trim().split(reg2points);
		var vt = [];
		vt.value = v[0];
		vt.text = v[0];
		out.push(vt);
	});	//alert(out.length);
	return(out);
}

function sejourDataVillesTarif(d) {
	var out = {};
	$.each(d.split(regVirgule), function (i, v) {
		var v = v.trim().split(reg2points);
		var k = v[0];
		out[k] = v[1];
	});
	return(out);
}

//~ function sejourSelectVilles(selectVilles, ref, sejours) {
	//~ GMS_selectOptionsUpdate(selectVilles, sejourDataVilles(sejours[ref].villes), true)
	//~ $(selectVilles).prop("selectedIndex",0).selectmenu("refresh");
//~ }
function sejourSelectVilles(selectVilles, periode) {
	if(periode.complet == '1') {
		selectVilles.attr('disabled', true).selectmenu('refresh');
	} else {
		GMS_selectOptionsUpdate(selectVilles, sejourDataVilles(periode.villes), true)
		selectVilles.removeAttr('disabled').prop("selectedIndex",0).selectmenu("refresh");
	}
}


$(document).ready(function ($) {

	// placement des éléments additionnels 

	$('#s-pj .pola').appendTo('#top-polas');
	eEmbeder($('#top-polas .pola'), 'top-pola-img');
	eEmbeder($('#top-polas .top-pola-img'), 'top-pola');

	eEmbeder($('#s-pj .bulle'), 'photo-sejour-img');
	$('#s-pj .photo-sejour-img').appendTo($('#sejour-slideshow'));
	//~ ImageResizeKeepRatioLoad($('.photo-sejour-img'));
	
	eEmbeder($('#s-pj .diapo'), 'diapo-sejour-img');
	eEmbeder($('#s-pj .diapo-sejour-img'), 'diapo-sejour');
	$('#s-pj .diapo-sejour').appendTo($('#sejour-diapos'));
	//~ ImageResizeKeepRatioLoad($('.diapo-sejour-img'), 2000);

	eEmbeder($('#post-others .post-image img'), 'post-other-img');
	//~ ImageResizeKeepRatioLoad($('.post-other-img'));

	var postOthersCount = $("#post-others .post-content div:nth-of-type(1) a").length;
	if(!postOthersCount) {
		postOthersCount = $("#post-others .post-content div:nth-of-type(2) a").length;
		$("#post-others .post-content div:nth-of-type(2)").show(0);
	}
	if(postOthersCount > 6) {
		$("#more-sejours").show();
	}

	// placement des fonds de séjour (si existants)
	if($('#s-pj .bandeau:first').length) {
		if(!$('#s-pj .bandeau-mini').length) {
			$("#s-pj .bandeau:first").clone().removeClass('bandeau').addClass('bandeau-mini').appendTo("#s-pj");
		}
		if(!$('#data-season [data-img_class=bandeau]').length) {
			$("#s-pj .bandeau:first").clone().appendTo("#data-season");
		}
		if(!$('#data-season [data-img_class=bandeau-mini]').length) {
			$("#s-pj .bandeau-mini:first").clone().appendTo("#data-season");
		}
		$('#data-season [data-img_class=bandeau]:first').attr('data-img_url', $('#s-pj .bandeau').attr('data-img_url'));
		$('#data-season [data-img_class=bandeau-mini]:first').attr('data-img_url', $('#s-pj .bandeau-mini').attr('data-img_url'));
		//~ '#data-season [data-img_class=bandeau]:first', '#data-season [data-img_class=bandeau-mini]:first'
		//~ if($('#s-pj .bandeau-mini').length) {
			//~ $('#data-season [data-img_class=bandeau-mini]:first').attr('data-img_url', $('#s-pj .bandeau-mini').attr('data-img_url'));
		//~ } else {
			//~ $('#data-season [data-img_class=bandeau-mini]:first').attr('data-img_url', $('#s-pj .bandeau').attr('data-img_url'));
		//~ }

		// en cas de redimensionement (event re-programmation)
		$(window).off('resize').resize(function() {
			if ($(window).width() <= viewport_small){ 
				$('body').css("background-image", 'url(' + $('#data-season [data-img_class=bandeau-mini]:first').attr('data-img_url') + ')');
			} else {
			$('body').css("background-image", 'url(' + $('#data-season [data-img_class=bandeau]:first').attr('data-img_url') + ')');
			}  
		});

		if ($(window).width() <= viewport_small){ 
			$('body').css("background-image", 'url(' + $('#data-season [data-img_class=bandeau-mini]:first').attr('data-img_url') + ')');
		} else {
			$('body').css("background-image", 'url(' + $('#data-season [data-img_class=bandeau]:first').attr('data-img_url') + ')');
		}  
	}
	
	sejourDescription('.sejour-activites', '#s-activites');
	sejourDescription('.sejour-esprit', '#s-esprit');
	sejourDescription('.sejour-environnement', '#s-environnement');
	sejourDescription('.sejour-hebergement', '#s-hebergement');
	sejourDescription('.sejour-indispensables', '#s-indispensables');
	sejourDescription('.sejour-capacite', '#s-capacite');


	// affectation des données séjour
	//atysEx_sejourInscription('#sejour-inscription');
	var durees = parseJSON($('#s-durees-json').text());
	console.log('durees: '); //console.log(durees);

	var dureesNum = [];
	$.each(durees, function(dureeText, periodes) {
		var dureeNum  = dureeText.replace("jours", "").trim();
		//console.log('dureeNum: '); //console.log(dureeNum);
		dureesNum.push(dureeNum);
	});

	// ajout des valeurs pour les pictos 'ages' et 'durees'
	// $('#s-durees').attr('data-value', dureesNum.reverse().join(',')); // affiche les pastilles "durées"
	$('#s-ages').attr('data-value', $('#s-ages').attr('data-value').split(regVirgule).reverse().join(','));

	// placement des pictos
	sejourPictoImg('#sejour-pictos', '#s-activite, #s-transport');
	sejourPictoTxt('#sejour-pictos', '#s-durees, #s-ages');


	//~ for(e of ['#sejour-inscription','#mini-sejour-inscription']) {
	for(e of ['#sejour-inscription']) {
		$.each(durees, function(dureeText, periodes) {
			var dureeId   = dureeText.replace(" ", "-");
			var dureeRefDefault = false;

			// clonage du 'tab'
			$(e+' ul li:first').clone().appendTo($(e+' ul'));
			var e_li = $(e+' ul li:last').html().replace("dureeId", dureeId).replace("dureeText", dureeText);
			$(e+' ul li:last').html(e_li);
			$(e+' .sejour-dureeId:first').clone().appendTo($(e));
			var e_div = $(e+' .sejour-dureeId:last').attr("class");
			$(e+' .sejour-dureeId:last').attr("id", e_div.replace("dureeId", dureeId));

			// remplissage des 'select'
			var periodeEnableFirst = '';
			$.each(periodes, function (ref, periode) {
				periode.datesDisplay = periode.dates;
				if(periode.complet=="1") {
					periode.datesDisplay += " - [Complet]";
				} else {
					if(periode.attente=="1") {periode.datesDisplay += " - [sur liste d'attente]";}
					else {
						if(periodeEnableFirst == '') {periodeEnableFirst = ref;}
					}
				}
				$(e+' #sejour-'+dureeId+' .sejour-periode').append($('<option>', {value: ref, text: periode.datesDisplay}));
			});
			if(periodeEnableFirst != '') {
				$(e+' #sejour-'+dureeId+' .sejour-periode option[value='+periodeEnableFirst+']').attr('selected', true);
			}
			
			if($('#sejour-villedepart').length) { console.log('tarif ville depart');

				// réglages du select .sejour-periode
				$(e+' #sejour-'+dureeId+' .sejour-periode').selectmenu({
					change: function(event, ui) {
						var t = $(this).parent().find(".sejour-tarif");
						var b = $(this).parent().find("button");
						var v = $(this).parent().find('.sejour-villedepart');
						var c = $(this).val();

						t.removeClass('active'); b.removeClass('active');

						//console.log(this.id+' : '+$(this).val());

						sejourSelectVilles(v, periodes[c]);
					}
				});

				// réglages du select .sejour-villedepart
				$(e+' #sejour-'+dureeId+' .sejour-villedepart').selectmenu({
					change: function(event, ui) {
						var reg = new RegExp('.+attente.+');
						//alert($(e+' .sejour-periode option:selected').text());
						if (  reg.test( $(this).parent().find('option:selected').text() )   ) {
							rmbShow("Sur liste d'attente","Attention, ce séjour est sur liste d'attente",'Fermer', 'rmb-classic rmb-content-center');
						}
						var d = sejourDataVillesTarif(periodes[$(this).parent().find(".sejour-periode").val()].villes);
						var v = ui.item.value;
						var t = $(this).parent().find(".sejour-tarif");
						var b = $(this).parent().find("button");
						t.text(d[v]);
						var Zcomplet = (periodes[$(this).parent().find(".sejour-periode").val()].complet === '1');
						if(v.length && !Zcomplet) {t.addClass('active'); b.addClass('active');}
						else {t.removeClass('active'); b.removeClass('active');}
					}
				});
				sejourSelectVilles($(e+' #sejour-'+dureeId+' .sejour-villedepart'), periodes[$(e+' #sejour-'+dureeId+' .sejour-periode option:selected').val()]);

			}
			else { console.log('tarif options');

				// réglages du select .sejour-periode
				$(e+' #sejour-'+dureeId+' .sejour-periode').selectmenu({
					change: function(event, ui) {
						var t = $(this).parent().find(".sejour-tarif");
						var b = $(this).parent().find("button");
						//~ var v = $(this).parent().find('.sejour-villedepart');
						var c = $(this).val();

						t.removeClass('active'); b.removeClass('active');

						//console.log(this.id+' : '+$(this).val());

						//~ sejourSelectVilles(v, periodes[c]);
					}
				});
			
				$(e+' #sejour-'+dureeId+' .prix-séjour button').show();
			
			}

//console.log('.sejour-periode option:selected');
//console.log($(e+' #sejour-'+dureeId+' .sejour-periode option:selected').val());

		});		

		$(e+' ul li:first').remove();
		$(e+' .sejour-dureeId:first').remove();

		// réglages des onglets .sejour-inscription
		$(e).tabs();

	}
	

	// réglages du slideshow
	$('#sejour-slideshow').GMS_slideShow({item:'.photo-sejour-img', delay:5000});

	// réglages des onglets .sejour-description
	$("#sejour-description").tabs({
		show: {effect: "fade", duration: 300}
	});

	// réglages de #sejour-commentaires button
	$("#sejour-commentaires button, #mini-comments button").button().click(function( event ) {
		if(commentFormState == 'active') { commentFormHide(); }
		else {commentFormShow(); }
		event.preventDefault();
	});

	if($('#sejour-programme').height() > 350) {
		$('#sejour-programme').addClass('minheight');
		$('#sejour-description>div .fixbtmax').show(500);
	}

	//~ $("#more-sejours a").click(function( event ) {
		//~ //$("#post-others .post-content").addClass('more-sejours');
		//~ $("#first-others").hide();
		//~ $("#all-others").show();
		//~ $(this).parent().hide(500);
		//~ event.preventDefault();
	//~ });

});

$(window).load(function(){
	//~ console.log('séjour window load : before ImageResizeKeepRatio : #sejour-diapos .diapo-sejour-img');
    ImageResizeKeepRatio($('#sejour-diapos .diapo-sejour-img'), 2000);

	//~ console.log('séjour window load : before ImageResizeKeepRatio : #sejour-slideshow .photo-sejour-img');
	ImageResizeKeepRatio($('#sejour-slideshow .photo-sejour-img'));

	//~ console.log('séjour window load : before ImageResizeKeepRatio : #post-others .post-other-img');
	ImageResizeKeepRatio($('#post-others .post-other-img'));
});

